function  [peaks] = AlignCenter3(peaks,pic,s1,s2,BSum, flag_expand)
    if (nargin<6),      flag_expand= 1;     end
    for move_center_times=1:10 %10
        peaks = AlignCenter2(peaks,pic,s1,s2);
    end
    
    if (flag_expand==1)
        peaks = Expand(peaks,pic,s1,s2);
    end
    peaks = UpdateSum(peaks,BSum);
end

function  [peaks] = AlignCenter2(peaks,pic,s1,s2)
% Now we only align the center and don't use another method
% such as remove rectangle if it is text
    h_s1 = ceil(s1/2); h_s2 = ceil(s2/2);    
    [maxx maxy] = size(pic);
    new_peaks = zeros(size(peaks));
    count = 0;
    for i=1:size(peaks,1)
       im = pic(peaks(i,1):peaks(i,1)+s1-1, peaks(i,2):peaks(i,2)+s2-1);

       % Align Center    
       [X Y] = find(im);
       cx=round(mean(X)); cy=round(mean(Y));       
       x = peaks(i,1); y=peaks(i,2);
       x2 = cx+x-h_s1;
       y2 = cy+y-h_s2;
       if (x2 < 1),               x2 = 1;   
       elseif (x2+s1 > maxx),     x2 = maxx-s1+1;
       end       
       if (y2 < 1),               y2 = 1;     
       elseif (y2+s2 > maxy),     y2 = maxy-s2+1;
       end
       
%        s = sum(sum(pic(x2:x2+s1-1, y2:y2+s2-1)));
        count = count+1;
        new_peaks(count,:) = [x2 y2 0];       % % sum will be updated later
    end
    peaks = unique(new_peaks(1:count,:), 'rows');
end
    
function peaks = Expand(peaks,pic,s1,s2)
    %% Expand to 8 neighborhood
    new_peaks = zeros(9*size(peaks,1), size(peaks,2));
    [maxx maxy] = size(pic);    
    for i=1:size(peaks,1)
        x = peaks(i,1); y = peaks(i,2); s = peaks(i,3);
        new_peaks(9*(i-1)+1:9*i, 3) = repmat(s , 9, 1);
        new_peaks(9*(i-1)+1, 1:2) = [x-1 y-1];
        new_peaks(9*(i-1)+2, 1:2) = [x   y-1];
        new_peaks(9*(i-1)+3, 1:2) = [x+1 y-1];
        new_peaks(9*(i-1)+4, 1:2) = [x-1 y];
        new_peaks(9*(i-1)+5, 1:2) = [x   y];
        new_peaks(9*(i-1)+6, 1:2) = [x+1 y];
        new_peaks(9*(i-1)+7, 1:2) = [x-1 y+1];
        new_peaks(9*(i-1)+8, 1:2) = [x   y+1];
        new_peaks(9*(i-1)+9, 1:2) = [x+1 y+1];        
    end
    b = find((new_peaks(:,1)<1) | (new_peaks(:,1)+s1>maxx) | ...
        (new_peaks(:,2)<1) | (new_peaks(:,2)+s2>maxy) );
    new_peaks(b,:) = [];
    peaks = new_peaks;
end    
    
function peaks = UpdateSum(peaks,BSum)
    index=(peaks(:,2)-1)*size(BSum,1)+peaks(:,1);
    peaks(:,3) = BSum(index);    
end
