%%    
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%    
function [score x y]= ght3(Q,C,sumQ,sumC)
    if (nargin < 4)
        sumQ = sum(sum(Q));
        sumC = sum(sum(C));
    end
    if ((sumQ==0)||(sumC==0))
        x=0; y=0;
        score = DistM3(0, sumQ, sumC);
        return;
    end
    
    [s1x s1y] = size(Q);
    [s2x s2y] = size(C);      

    [r,c] = find(Q);
    cen_x = round(mean(r));
    cen_y = round(mean(c));
    Vx = cen_x - r;
    Vy = cen_y - c;
        
    % Match Matrix keeps the result
    % output size is quite big. We can reduce if we need
    M = zeros(s2x+2*s1x, s2y+2*s1y);
    sm = size(M,1);
    sv = size(Vx,1);
    [r,c] = find(C);
    for i=1:sv
        Tx = Vx(i)+r +s1x;
        Ty = Vy(i)+c +s1y;        
        M(Tx + sm*(Ty-1)) = M(Tx + sm*(Ty-1)) +1;
    end
    
    [match_score index] = max(M(:));
    x = mod(index-1,sm)+1 - s2x +1;
    y = ceil(index/sm)    - s2y +1;
    d_cq = (cen_x - s1x/2)*(cen_x - s1x/2) + (cen_y - s1y/2)*(cen_y - s1y/2);
    d_cc = (x - s2x/2)*(x - s2x/2) + (y - s2y/2)*(y - s2y/2);
    d_cen = d_cq + d_cc;
       
    %score = sumQ - match_score;      % normal ght
    score = DistM3(match_score, sumQ, sumC, d_cen);
    
